/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include "Driver\DrvUART.h"
#include "Driver\DrvGPIO.h"
#include "Driver\DrvSYS.h"
#include "NUC1xx.h"

// GPIOA.0  -> SRF Pin Trig.  GPIOA.0ΪSRFTrigźŽ
// GPIOB.14 -> SRF Pin Echo.  GPIOB.14ΪSRFECHOźŽ

volatile uint32_t u32SysTickPer10Us = 0;
volatile uint32_t u32IsEchoFinish = 0;

void delay(uint32_t u32cnt)
{
    while(u32cnt--)
    {
        __NOP();
        __NOP();
    }
}

void EINT0Callback(void)
{
    uint32_t u32status;

    u32status = GPIOB->PIN;
    
    if ((u32status & BIT14) != 0)       // GPIOB.14ǷΪ
    {
        u32SysTickPer10Us = 0;

        /* SysTickSRFز*/
        SysTick->LOAD = CyclesPerUs*10; // SysTick= 10 us
        SysTick->VAL  = 0x00;
        /* SysTickʱԴΪHCKLSysTickжϣSysTickʼ. */
        SysTick->CTRL = SysTick_CTRL_CLKSOURCE_Msk | SysTick_CTRL_TICKINT_Msk | SysTick_CTRL_ENABLE_Msk;
    }
    else
    {
        SysTick->CTRL = 0;              // ֹͣ
        u32IsEchoFinish = 1;
    }
}

void SysTick_Handler(void)
{ 
    u32SysTickPer10Us++;                // ÿ10usһ
}

int32_t main()
{
    uint32_t u32distance;

    UNLOCKREG();
    SYSCLK->PWRCON.XTL12M_EN = 1;

    DrvSYS_Delay(5000);                         // ȴⲿȶ

    DrvSYS_Open(50000000);                      // HCLK = PLL, PLL clock = 50 MHz

    /* EINT0Echoźŵ½ */
    DrvGPIO_InitFunction(E_FUNC_EXTINT0);       // GPIOB.14 Ϊⲿж
    DrvGPIO_SetDebounceTime(8, E_DBCLKSRC_HCLK);// 趨Ϊ256HCLK clock
    DrvGPIO_EnableDebounce(E_GPB, 14);          // GPIOB.14 

    /* EINIT0ж,жģʽΪغ½ش,EINT0 call back */
    DrvGPIO_EnableEINT0(E_IO_BOTH_EDGE, E_MODE_EDGE, EINT0Callback);

    DrvGPIO_ClrBit(E_GPA, 0);

    while (1)
    {
        /* һ10uSȵĴźŸSRF */
        DrvGPIO_SetBit(E_GPA, 0);
        delay(50);
        DrvGPIO_ClrBit(E_GPA, 0);

        u32IsEchoFinish = 0;
        while(u32IsEchoFinish == 0);            // ȴecho

        /* ͨزźſȼ                */
        /* ģ鷢ٷ,ٶΪ340m/s */
        /* ; = ز * 340m/s / 2        */
        /*          = ز * 0.017cm/us        */
        u32distance = u32SysTickPer10Us*10*17;
        printf("Echo Width = %dus, Object Distance = %d.%d cm\n", u32SysTickPer10Us*10, u32distance/1000, u32distance%1000);
        
        delay(5000000);                         // ӳ 1s
        delay(5000000);                         // ӳ 1s
    }
}


